﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private pnlSite As Panel
	Private pnlTime As Panel
	Private pnlTimeRel As Panel
	Private tbhMain As TabHost
	Private firstTimeinTab As Boolean : firstTimeinTab = False
	Private THExtra As TabHostExtras
	
	Dim dtePick As ClsWheel
' Schedule Screen
	Dim tblSchedule As Table
	Private edtNotes As EditText
	Private lblScheduled As Label
	Private txtSchedUnit As Label
	Private lblUnit As Label
	Private lblWorktodo As Label
	Private Panel1 As Panel
	Private Panel2 As Panel
	Private Panel3 As Panel
	Private PnlBase As Panel
	Private txtWorktoDo As Label
	Private valWkId As String
	Private valSDate As String
	Private valNotes As String
	Private valSTime As String
	Private	valUnit As String
	Private valStatus As String
	Private valRowId As String
	Private currentrow As Int
	Private myIME As IME
	Private btnDoneEdit As Button
	Private txtTime As Label
	Private spnSDate As ClsWheel
	Private spnSTime As ClsWheel
	Private txtSDate As Label
	Private txtSTime As Label

'  Site Screen
	Dim siteMap As Map
	siteMap.Initialize
	Private txtUnit As Label
	Private lblPDesc1 As EditText
	Private lblPDesc2 As EditText
	Private txtAddr1 As Label
	Private txtAddr2 As Label
	Private txtAddr3 As Label
	Private txtCID As Label
	Private txtCity As Label
	Private lblContact As Label
	Private txtContact As EditText
	Private txtMan As Label
	Private txtPhne1 As MaskedEditText
	Private txtPhne2 As MaskedEditText
	Private txtPID As Label
	Private txtPostal As Label
	Private txtRMan As Label
	Private txtRPhne As Label
	Private txtType As Label
	Private imgMap As ImageView
	Private txtProv As Label
	Private lblProv As Label
	
	' Time Sheets

	Dim tblTime1 As Table
	Dim tblTime2 As Table
	Private pnlTimeList As Panel
	Private spnTStart As ClsWheel
	Private spnTEnd As ClsWheel
	Private valTStart As String
	Private valTEnd As String
	Private txtTSDate As Label
	Private txtTEDate As Label
	Private btnSave As Button
	Private btnAdd As Button
	Private btnDelete As Button
	Private btnEdit As Button
	Private btnStart As Button
	Private btnStop As Button	
	Private timeMap As Map
	Private currentTimeRow As Int
	
	Private skip As Boolean
	Private addNew As Boolean


End Sub

Sub Activity_Create(firstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("SchdMain")

	currentrow = -1

	ProgressDialogShow2("Loading....",False)		
 	AddViews

	myIME.Initialize("myIME")
	timeMap.Initialize()
	Activity.Title="WO: "&Main.WO
	LoadSite
	LoadSchedule_MainTime
	If tblSchedule.Size>0 Then
		Dim rowccol As RowCol
		rowccol.Col=0
		rowccol.Row=0
		tblSchedule.SelectRow(rowccol)
		TblSchedule_CellClick(0,0)
		tblTime1.SelectRow(rowccol)
	End If
			ProgressDialogHide
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
If UserClosed Then
	Activity.Finish
End If
End Sub

Sub LoadSchedule_MainTime
		tblSchedule.ClearAll
		tblSchedule.LoadSQLiteDB(Main.SQL1,SQLScripts.LoadWOSchedule(Main.WO),True)
		
		tblSchedule.SetHeader(Array As String("Rel#", "Work to Do","Assigned Date","Status","RowId"))
		tblSchedule.SetColumnsWidths(Array As Int(40dip,80dip,120dip,80dip,10dip))
		tblSchedule.hideCol(4)
		
		tblTime1.ClearAll
		tblTime1.LoadSQLiteDB(Main.SQL1,SQLScripts.LoadWOSchedule(Main.WO),True)
		tblTime1.SetHeader(Array As String("Rel#", "Work to Do","Assigned Date","Status","RowId"))
		tblTime1.SetColumnsWidths(Array As Int(40dip,80dip,120dip,80dip,10dip))
		tblTime1.hideCol(4)
		
End Sub

Sub LoadSite
	siteMap.Clear
	siteMap = DBUtils.ExecuteMap(Main.SQL1,SQLScripts.LoadSiteInfo(Main.WO),Null)
	txtCID.Text = siteMap.Get("cid")
	txtPID.Text = siteMap.Get("pid")
	txtUnit.Text = siteMap.Get("unit")
	txtAddr1.Text = siteMap.Get("addr1")
	txtAddr2.Text = siteMap.Get("addr2")
	txtAddr3.Text = siteMap.Get("addr3")
	txtCity.Text = siteMap.Get("city")
	txtPostal.Text = siteMap.Get("zip")
	txtProv.Text = siteMap.Get("st")
	txtContact.Text = siteMap.Get("cname")
	txtPhne1.Text = FormatPhone(siteMap.Get("phne1"))
	txtPhne2.Text = FormatPhone(siteMap.Get("phne2"))
	lblPDesc1.Text = siteMap.Get("pdesc1")
	lblPDesc2.Text = siteMap.Get("pdesc2")
	txtRMan.Text = siteMap.Get("rpm")
	txtRPhne.Text = FormatPhone(siteMap.Get("rphne"))
	txtMan.Text = siteMap.Get("man")
	txtType.Text = siteMap.Get("wtyp")
	
	Dim pri As Int
	Dim priColor As Int : priColor = Colors.White	
	pri =  siteMap.Get("pri")
	Select pri
		Case 2
			priColor= Colors.LightGray
		Case 5
			priColor= Colors.Yellow
		Case 9
			priColor= Colors.Red
	End Select
	
	txtType.Color = priColor
	
	
End Sub

Sub AddViews
	
	tbhMain.AddTab("Site","Site")
	tbhMain.AddTab("Schedule","Schedule")
	tbhMain.AddTab("Time","Time")
	
	THExtra.setTabHeight(tbhMain,80)
	THExtra.setTabTextSize(tbhMain, 14)
	
	
	dtePick.Initialize(Me,Panel2 ,"Enter Time",0,Null,15,1,True)
	dtePick.Top = 930	
	dtePick.Left = 480
	dtePick.Width = 220
	
	
	
	tblSchedule.Initialize(Me,"TblSchedule",5,0,True)
	tblSchedule.AddToView(Panel1,0,0,100%x,100%y)
	tblSchedule.SetHeader(Array As String("Release", "Work to Do","Assigned Date","Status","RowId"))
	tblSchedule.TextSize = 14
	tblSchedule.HeaderColor = Colors.Blue
	tblSchedule.HeaderTextColor = Colors.White
	tblSchedule.RowColor1 = Colors.LightGray
	tblSchedule.RowColor2 = Colors.White
	tblSchedule.TextColor = Colors.Black
	tblSchedule.SelectedRowColor = Colors.Green
 	tblSchedule.Visible = True
	' tblSchedule.RowHeight =  40dip
	
	tblTime1.Initialize(Me,"tblTime1",5,0,True)
	tblTime1.AddToView(pnlTimeRel,0,0,100%x,100%y)
	tblTime1.SetHeader(Array As String("Release", "Work to Do","Assigned Date","Status","RowId"))
	tblTime1.TextSize = 14
	tblTime1.HeaderColor = Colors.Blue
	tblTime1.HeaderTextColor = Colors.White
	tblTime1.RowColor1 = Colors.LightGray
	tblTime1.RowColor2 = Colors.White
	tblTime1.TextColor = Colors.Black
	tblTime1.SelectedRowColor = Colors.Green
 	tblTime1.Visible = True
	' tblTime1.RowHeight =  40dip

	tblTime2.Initialize(Me,"tblTime2",6,0,True	)

	tblTime2.AddToView(pnlTimeList,0,0,100%x,100%y)
	tblTime2.SetHeader(Array As String("RecNo","Start","End","Hrs","Seq","Post"))
	tblTime2.TextSize = 14
	tblTime2.HeaderColor = Colors.Blue
	tblTime2.HeaderTextColor = Colors.White
	tblTime2.RowColor1 = Colors.LightGray
	tblTime2.RowColor2 = Colors.White
	tblTime2.TextColor = Colors.Black
	tblTime2.SelectedRowColor = Colors.Green
 	tblTime2.Visible = True

	edtNotes.Color = Colors.White  
	
	
	txtPhne1.Initialize("txtPhne1")
	txtPhne1.Format="###-###-####"
	txtPhne1.InputType = txtPhne1.INPUT_TYPE_PHONE
	txtPhne1.SingleLine=True
	txtPhne1.TextSize = 20
	txtPhne1.Color = Colors.Black
	txtPhne1.ForceDoneButton = True
	pnlSite.AddView(txtPhne1,330,810,510,81)
	
	txtPhne2.Initialize("txtPhne2")
	txtPhne1.Format="###-###-####"
	txtPhne2.InputType = txtPhne2.INPUT_TYPE_PHONE
	txtPhne2.SingleLine=True
	txtPhne2.TextSize = 20
	txtPhne2.Color = Colors.Black
	txtPhne2.ForceDoneButton = True
	pnlSite.AddView(txtPhne2,330,900,510,81)

	spnSDate.Initialize(Me,Activity,"Schedule Date",0,Null,14,0,True)
	spnSDate.Top=690
	spnSDate.Left=330
	spnSDate.Height=81
	spnSDate.Width=330

	spnSTime.Initialize(Me,Activity,"Scheduled Time",0,Null,14,1,True)
	spnSTime.Top=780
	spnSTime.Left=330
	spnSTime.Height=81
	spnSTime.Width=330
	
		spnTStart.Initialize(Me,Activity,"Start Time",0,Null,14,3,True)
		spnTEnd.Initialize(Me,Activity,"End Time",0,Null,14,3,True)

End Sub

Sub FormatPhone(n As String) As String
   Dim R As Reflector
   Return R.RunStaticMethod("android.telephony.PhoneNumberUtils", "formatNumber", _
     Array As Object(n), Array As String("java.lang.String"))
End Sub

Sub TblSchedule_CellClick(Col As Int, row As Int)
If row <> currentrow Then
	If currentrow	<> -1 Then
		UpdateCurrentSchedule
	End If
	currentrow = row
	tblSchedule.JumpToRowAndSelect(currentrow	,-1)

	If skip = False Then
		skip = True ' flag to keep from an endless loop
		TblTime1_CellClick(Col,row)
		skip = False
	End If
	Dim Wdnum As String
	Wdnum = tblSchedule.GetValue(0,row)
	valWkId = tblSchedule.GetValue(1,row)	
	
	Dim siteMap As Map
	siteMap.Initialize
	siteMap = DBUtils.ExecuteMap(Main.SQL1,SQLScripts.LoadDetails(Main.WO,Wdnum),Null)
	If siteMap <> Null Then
		valUnit = siteMap.Get("unit")
		valSDate = siteMap.Get("sdat")
		valSTime = siteMap.Get("stim")
		valStatus = siteMap.Get("status")
		valNotes = siteMap.Get("notes")
		DateTime.DateFormat = "yyyy-MM-dd"		
		txtSchedUnit.Text = valUnit
		txtWorktoDo.Text = valWkId
		txtSDate.Text = valSDate
		txtSTime.Text = valSTime
		If (valSDate = "" OR valSDate.Length=0) Then
		'	dteScheduled.SetDate(-1,True)
			
		Else
		'	dteScheduled.SetDate(DateTime.DateParse(valSDate),True)
		End If
		edtNotes.Text = valNotes
	End If
End If
End Sub

Sub TblTime1_CellClick(Col As Int, row As Int)

	
	currentrow = row
	
	Dim Wdnum As String
	Wdnum = tblTime1.GetValue(0,row)
	
	RefreshTimeDetail(Wdnum)

			
		tblTime1.JumpToRowAndSelect(currentrow	,-1)
		If skip = False Then
			skip = True
			TblSchedule_CellClick(Col,row)
			skip = False
		End If
		If tblTime2.Size>0 Then
			tblTime2.JumpToRowAndSelect(0,-1)
			TblTime2_CellClick(0,0)
			Else
				currentTimeRow = -1
				valTStart = ""
				valTEnd = ""
				txtTSDate.Text = ""
				txtTEDate.Text = ""
		End If

btnSave.Visible = False
btnAdd.Visible = True

If CheckForOpenTime Then	
		btnStart.Visible = False 
	Else
		btnStart.Visible = True
	End If
	
	If currentTimeRow <> -1 Then
		btnEdit.Visible = True
		btnDelete.Visible = True
	Else
		btnEdit.Visible = False
		btnDelete.Visible = False
	End If
		
End Sub

Sub RefreshTimeDetail(Wdnum As String)
		tblTime2.ClearAll
		DateTime.DateFormat = "yyyy-MM-dd HH:mm"	
		tblTime2.LoadSQLiteDB(Main.SQL1,SQLScripts.LoadTime(Main.WO,Wdnum),False)
		' tblTime2.RowHeight = 30dip
		tblTime2.SetHeader(Array As String("RecNo","Start","End","Hrs","Seq","Post"))
		tblTime2.SetColumnsWidths(Array As Int(00dip,120dip,120dip,50dip,0dip,30dip))
		tblTime2.hideCol(0)
		tblTime2.hideCol(4)
		
		
End Sub

Sub TblTime2_CellClick(Col As Int, row As Int)
	currentTimeRow = row
	Dim rowId As String
	rowId = tblTime2.GetValue(0,row)

		valTStart = ""
		valTEnd   = ""

	
	timeMap.Clear
	timeMap = DBUtils.ExecuteMap(Main.SQL1,SQLScripts.LoadTimeDetail(rowId),Null)

			
		valTStart = StripDateTime(timeMap.Get("start_dt"))
		valTEnd   = StripDateTime(timeMap.Get("end_dt"))
	 	txtTSDate.Text = valTStart
		txtTEDate.Text = valTEnd
		
		tblTime2.JumpToRowAndSelect(row,-1)
	
	
		If valTEnd <> "null" AND valTEnd <> "" Then btnStop.Visible = False Else btnStop.Visible = True		
		If timeMap.Get("Posted") = "1" Then btnDelete.Visible = False Else btnDelete.Visible = True
	
End Sub

Sub dteScheduled_Closed (Cancelled As Boolean, Date As Long)
	If Cancelled = False Then
		If Date <> -1 Then
	'		valSDate = DateTime.Date(dteScheduled.GetDate)

		Else 
			valSDate = ""

		End If
		
	End If
End Sub

Sub UpdateCurrentSchedule
		valNotes = edtNotes.Text
		
		
		
End Sub

Sub btnDoneEdit_Click
		myIME.HideKeyboard
		Panel1.Height = 450dip
		Panel3.Height = 180dip
		Panel2.Top = 630dip
		btnDoneEdit.Visible = False
		lblScheduled.RequestFocus
End Sub


Sub edtNotes2_FocusChanged (HasFocus As Boolean)
	If( HasFocus AND firstTimeinTab = False) Then
		Panel1.Height = 0
		Panel3.Height=0
		Panel2.Top=0
		btnDoneEdit.Visible = True
	Else
		firstTimeinTab = False
	End If
End Sub

Sub edtNotes2_Click
	If firstTimeinTab Then
		 lblScheduled.RequestFocus 'First time into Tab, do not focus on Edit Box
	Else
		Panel1.Height = 0
		Panel3.Height=0
		Panel2.Top=0
		btnDoneEdit.Visible = True
	End If
End Sub

Sub txtTime_Click
			dtePick.Show(txtTime,valSTime)	
End Sub
Sub tbhMain_TabChanged
		If tbhMain.CurrentTab = 1 Then
			firstTimeinTab = False
		End If
			
End Sub


Sub lblPDesc1_TextChanged(Old As String, New As String)
	If New.Length>10 Then 
		lblPDesc1.text = Old 
	End If
End Sub

Sub lblPDesc2_TextChanged(Old As String, New As String)
	If New.Length>10 Then 
		lblPDesc2.text = Old 
	End If
End Sub

Sub txtContact_TextChanged(Old As String, New As String)
	If New.Length>20 Then 
		txtContact.text = Old 
	End If
End Sub
Sub imgMap_Click
		Dim i As Intent
		
		Dim addr,url As String
		
		addr = EscapeString(txtAddr1.Text)
		If (EscapeString(txtAddr2.Text) <> "") Then addr = addr & "+"& EscapeString(txtAddr2.Text)
		If (EscapeString(txtAddr3.Text) <> "") Then addr = addr & "+"&EscapeString(txtAddr3.Text)
		If (EscapeString(txtCity.Text) <> "") Then addr = addr & ","&EscapeString(txtCity.Text)
		If (EscapeString(txtProv.Text) <> "") Then addr = addr & ","&EscapeString(txtProv.Text)
		url = "https://maps.google.com/maps?q=" & addr	
		' url = "google.navigation:&q=" & addr
		url = url & "&zoom=18&maptype=roadmap"
		i.Initialize(i.ACTION_VIEW,url)
		i.SetComponent("com.google.android.apps.maps/com.google.android.maps.MapsActivity")

		StartActivity(i)
End Sub

Sub EscapeString(Str As String) As String
Dim deststr As String
	deststr = Str.Trim
	deststr = deststr.Replace(" ","+")
	deststr = deststr.Replace(".","")
	deststr = deststr.Replace("-","")
	Return deststr
End Sub

Sub UpdateCurrentTime

		Dim Wdnum As String
		Wdnum = tblTime1.GetValue(0,currentrow)
	
	If timeMap.Size=0 Then ' New ENtry
		timeMap.Clear
		
		timeMap.Put("wdnum",Wdnum)
		timeMap.Put("word",Main.WO)
		timeMap.Put("emp",Main.EmpId)
		DateTime.DateFormat = "yyyy-MM-dd HH:mm"	
		timeMap.Put("start_dt",valTStart)
		timeMap.Put("end_dt",valTEnd)
		timeMap.Put("ttime",CalcElapsedTime(valTStart,valTEnd))
		Dim Seq As Double : 
		Dim cu As Cursor

		cu = Main.SQL1.ExecQuery( SQLScripts.NextTimeSequence(Main.WO,Wdnum))
		If cu.RowCount>0 Then
			cu.Position = 0
			Seq = cu.GetDouble("seq") +1
		Else
			Seq = 0
		End If
		cu.Close
		timeMap.Put("seq",NumberFormat(Seq,2,0))
			Dim ListOfMaps As List
    	ListOfMaps.Initialize
			ListOfMaps.Add(timeMap)
			DBUtils.InsertMaps(Main.SQL1,"WoTime",ListOfMaps)
			RefreshTimeDetail(Wdnum)
			
			tblTime2.JumpToRowAndSelect(tblTime2.Size-1	,-1)
			TblTime2_CellClick(1,tblTime2.Size-1)	
	Else
	 	
		Dim UpdateMap As Map : UpdateMap.Initialize
		Dim WhereMap As Map : WhereMap.Initialize
		If valTStart <> timeMap.Get("start_dt") Then
			UpdateMap.Put("start_dt",valTStart)
			timeMap.Put("start_dt",valTStart)
			tblTime2.SetValue(1,currentTimeRow,valTStart)
		End If
		If valTEnd <> timeMap.Get("end_dt") Then
			UpdateMap.Put("end_dt",valTEnd)
			timeMap.Put("end_dt",valTEnd)
			tblTime2.SetValue(2,currentTimeRow,valTEnd)
		End If
		If CalcElapsedTime(valTStart,valTEnd) <> timeMap.Get("ttime") Then
			UpdateMap.Put("ttime",CalcElapsedTime(valTStart,valTEnd))
			timeMap.Put("ttime",CalcElapsedTime(valTStart,valTEnd))
			tblTime2.SetValue(3,currentTimeRow,timeMap.Get("ttime"))
		End If
		WhereMap.put("word",Main.WO)
		WhereMap.put("wdnum",Wdnum)
		WhereMap.Put("seq",timeMap.Get("seq"))
		
		DBUtils.UpdateRecord2(Main.SQL1,"WoTime",UpdateMap,WhereMap)
				
	End If
	
	If CheckForOpenTime Then	
			btnStart.Visible = False 
	Else
			btnStart.Visible = True
	End If

	If valTEnd <> "null" AND valTEnd <> "" Then
			btnStop.Visible = False
	Else
			btnStop.Visible = True
	End If

	
End Sub

Sub StripDateTime(dt As String) As String ' Strips off extra Time info from a Date Time string leaving just date and HH:mm
Dim result = dt
If ( dt.Length>16) Then
	result = dt.SubString2(0,17) 
End If
Return result
End Sub

Sub CalcElapsedTime(sdate As String,edate As String) As String
Dim result As String
	If (sdate<> "" AND edate <> "" ) Then
		Dim sd,ed,st,et As String
		
		
		Dim Pd As Period
		DateTime.DateFormat = "yyyy-MM-dd HH:mm"
		Pd = DateUtils.PeriodBetweenInDays(DateTime.DateParse(sdate),DateTime.DateParse(edate))
			If (Pd.Days>0) Then 
			Msgbox("To long a time span between start and end, please correct","Error")
				result = "Err"
			Else
				If (Pd.Days<0 OR Pd.hours<0 OR Pd.Minutes <0) Then
					Msgbox("End Date/Time is before Start, please correct","Error")
					result = "Err"
				Else
			 		result= NumberFormat(Pd.Hours,2,0)&":"&NumberFormat(Pd.Minutes,2,0)
			 	End If
			 End If
	Else
		result = ""
	End If
	Return result
End Sub

Sub txtSDate_Click
	spnSDate.Show(txtSDate,valSDate)
End Sub
Sub txtSTime_Click
	spnSTime.Show(txtSTime,valSTime)
End Sub

Sub spnSDate_Closed(Cancelled As Boolean,Selection As String)
	valSDate = Selection
End Sub

Sub spnSTime_Closed(Cancelled As Boolean,Selection As String)
	valSTime = Selection
End Sub

'   Time Sheet Events *********************************************************



Sub btnAdd_Click
	btnStart.Visible = False
	btnStop.Visible = False
	btnEdit.Visible = False
	btnDelete.Visible = False
	btnAdd.Visible = False
	btnSave.Visible = True
	
	DateTime.DateFormat =  "yyyy-MM-dd"
	DateTime.TimeFormat  = "HH:mm"
	
	valTStart = DateTime.Date(DateTime.Now)&" "&DateTime.Time(DateTime.Now)
	valTEnd = ""
	txtTSDate.Text = ""
	txtTEDate.Text = ""

	timeMap.Clear
	txtTSDate.Enabled = True
	txtTEDate.Enabled = True
	txtTSDate_Click
	
End Sub
Sub btnStop_Click
Dim tedat As String = timeMap.Get("end_dt")
	If tedat <> "null" AND tedat <> "" Then
		Msgbox("End Time already entered, please select an open Time Entry","Warning!!")
	Else
		Dim nt As String 
		DateTime.DateFormat =  "yyyy-MM-dd"
		DateTime.TimeFormat  = "HH:mm"
		nt = DateTime.Date(DateTime.Now)& " " & DateTime.Time(DateTime.Now)
		valTEnd = nt
		txtTEDate.Text = nt
		btnSave_Click
	End If
End Sub
Sub btnStart_Click
	txtTEDate.Text = ""
	valTEnd = ""
	timeMap.Clear
	DateTime.DateFormat =  "yyyy-MM-dd"
	DateTime.TimeFormat  = "HH:mm"
	Dim nt As String 
	nt = DateTime.Date(DateTime.Now)& " " & DateTime.Time(DateTime.Now)
	txtTSDate.Text = nt
	valTStart = nt
	btnStart.Visible = False
	btnSave_Click
End Sub

Sub btnEdit_Click
	btnStart.Visible = False
	btnStop.Visible = False
	btnEdit.Visible = False
	btnDelete.Visible = False
	btnAdd.Visible = False
	btnSave.Visible = True
	txtTSDate.Enabled = True
	txtTEDate.Enabled = True
End Sub
Sub btnDelete_Click
	If timeMap.Size <> 0 Then
		If timeMap.Get("Posted") = "1" Then
			Msgbox("Entry has been downloaded, cannot delete","Warning")
		Else
			Dim result As Int
			result = Msgbox2("Are you sure you want to delete this entry?","Delete Time","Ok","Cancel","",Null)
			If result = DialogResponse.POSITIVE Then
			Dim Wdnum As String
			Wdnum = tblTime1.GetValue(0,currentrow)
			Dim sqlstmt As String
			sqlstmt = SQLScripts.DeleteTimeEntry(Main.WO,Wdnum,timeMap.Get("seq") )
				Main.SQL1.ExecNonQuery(sqlstmt)
					tblTime2.RemoveRow(currentTimeRow)
					currentTimeRow = currentTimeRow-1
					If currentTimeRow = -1 AND tblTime2.Size>0 Then currentTimeRow=0
					If currentTimeRow <> -1 Then 
						TblTime2_CellClick(0,currentTimeRow)
					Else
						btnDelete.Visible=False
						btnEdit.Visible=False
						btnSave.Visible = False
						btnStop.Visible = False
						valTStart = ""
						valTEnd = ""
						txtTSDate.Text = ""
						txtTEDate.Text = ""
					End If
			End If
		End If
	End If
	
	
End Sub

Sub btnSave_Click

	If  CalcElapsedTime(valTStart,valTEnd) = "Err" Then
		Msgbox2("Invalid Date/Time Range, please correct","Warning", "Ok","","",Null )
	Else
		If  CheckForOpenTime  Then 
		 	btnStart.Visible = False
			Else
			btnStop.Visible = False 
		End If
		btnEdit.Visible = True
		btnDelete.Visible = True
		btnAdd.Visible = True
		btnSave.Visible = False
		txtTSDate.Enabled = False
		txtTEDate.Enabled = False
		UpdateCurrentTime
	End If
	
End Sub

Sub txtTSDate_Click
	DateTime.DateFormat =  "yyyy-MM-dd"
	DateTime.TimeFormat  = "HH:mm"
	spnTStart.Show2("spnTStart",valTStart)
End Sub
Sub txtTEDate_Click
	DateTime.DateFormat =  "yyyy-MM-dd"
	DateTime.TimeFormat  = "HH:mm"
	spnTEnd.Show2("spnTEnd",valTEnd)
End Sub

Sub spnTStart_Closed(Cancelled As Boolean,Selection As String)
	If Cancelled <> True Then
		valTStart = Selection.Replace("/","")
		txtTSDate.Text =  Selection.Replace("/","")
		If CalcElapsedTime(valTStart,valTEnd) = "Err" Then
			valTStart = ""
			txtTSDate.Text = ""
		End If
	End If
End Sub

Sub spnTEnd_Closed(Cancelled As Boolean,Selection As String)
	If Cancelled <> True Then
		valTEnd = Selection.Replace("/","")
		txtTEDate.Text = Selection.Replace("/","")
		If CalcElapsedTime(valTStart,valTEnd) = "Err" Then
			valTEnd = ""
			txtTEDate.Text = ""
		End If
	End If
End Sub

Sub CheckForOpenTime() As Boolean
	Dim result As Boolean
	result = False
	For i=0 To tblTime2.Size -1
		If tblTime2.GetValue(2,i) = "" OR tblTime2.GetValue(2,i) = "null" Then
			result = True
		End If
	Next
	Return result
End Sub